<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:p="http://primefaces.org/ui"
                template="/templates/template.xhtml"
                >


    <ui:define name="conteudo">

        <h:form id="formListagem">
            <p:panel header="Lista de Produtos ">
                <p:dataTable id="tabela" emptyMessage="Nenhum registro encontrado."
                             paginator="true" value="#{produtoBean.produtos}" var="produto"
                             rows="5">
                    <f:facet name="header">
                        <p:commandButton value="Novo" actionListener="#{produtoBean.novo}"
                                         oncomplete="PF('dialogo').show();"
                                         update=":mensagem :formCadastro:painel">
                            <f:actionListener
                                type="org.omnifaces.eventlistener.ResetInputAjaxActionListener" />
                        </p:commandButton>
                    </f:facet>

                    <p:column headerText="Codigo" style="text-align: center;">
                        <h:outputText value="#{produto.codigo}" />
                    </p:column>


                    <p:column headerText="Codigo de Barras" style="text-align: center;">
                        <h:outputText value="#{produto.codigoProduto}" />
                    </p:column>

                    <p:column headerText="Marca:" style="text-align: center;" filterBy="#{produto.marca}"
                              sortBy="#{produto.marca}">
                        <h:outputText value="#{produto.marca}" />                           
                    </p:column>

                    <p:column headerText="Descrição" filterBy="#{produto.descricao}" 
                              filterMatchMode="contains" style="text-align: center;"
                              sortBy="#{produto.descricao}">
                        <h:outputText value="#{produto.descricao}" />
                    </p:column>

                    <p:column headerText="Data validade" 
                              filterBy="#{produto.validade}" 
                              filterMatchMode="contains" style="text-align: center;" 
                              sortBy="#{produto.validade}"  >
                        <h:outputText value="#{produto.validade}" >
                            <f:convertDateTime locale="pt_BR" />
                        </h:outputText>
                    </p:column>




                    <p:column headerText="Opções" style="text-align: center;">
                        <p:commandButton icon="ui-icon-trash"
                                         actionListener="#{produtoBean.excluir}"
                                         update=":mensagem :formListagem:tabela">
                            <p:confirm header="Confirmação"
                                       message="Deseja excluir o produto?" icon="ui-icon-alert" />
                            <f:attribute name="produtoSelecionado" value="#{produto}" />
                        </p:commandButton>

                        <p:commandButton icon="ui-icon-pencil"
                                         actionListener="#{produtoBean.editar}"
                                         update=":mensagem :formCadastro:painel"
                                         oncomplete="PF('dialogo').show();">
                            <f:attribute name="produtoSelecionado" value="#{produto}" />
                            <f:actionListener
                                type="org.omnifaces.eventlistener.ResetInputAjaxActionListener" />
                        </p:commandButton>

                        <p:commandButton icon="ui-icon-arrowthick-1-s" actionListener="#{produtoBean.download}" ajax="false">
                            <f:attribute name="produtoSelecionado" value="#{produto}" />
                            <p:fileDownload value="#{produtoBean.foto}"/>
                        </p:commandButton>
                    </p:column>
                </p:dataTable>

                <p:confirmDialog global="true" >
                    <p:commandButton value="Sim" type="button"
                                     styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
                    <p:commandButton value="Não" type="button"
                                     styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
                </p:confirmDialog>
            </p:panel>
        </h:form>

        <p:dialog header="Produtos - Cadastro" widgetVar="dialogo"
                  draggable="true" resizable="false"  closable="false">
            <h:form id="formCadastro"  enctype="multipart/form-data">
                <h:panelGrid id="painel" columns="2">


                    <p:outputLabel value="Marca:" />
                    <p:inputText maxlength="50" size="30"
                                 value="#{produtoBean.produto.codigo}" required="true"
                                 requiredMessage="O campo 'descrição é obrigatório" readonly="true"/>


                    <p:outputLabel value="Codigo do Produto:" />
                    <p:inputText maxlength="5" size="10"
                                 value="#{produtoBean.produto.codigoProduto}" required="true"
                                 requiredMessage="O campo 'Codigo' é obrigatório"
                                 converterMessage="Informe um valor valido para o campo 'Codigo'"
                                 validatorMessage="Informe um valor acima de 1 para o campo 'Codigo'">
                        <f:validateLongRange minimum="1" maximum="10000" />
                    </p:inputText>


                    <p:outputLabel value="Marca:" />
                    <p:inputText maxlength="50" size="30"
                                 value="#{produtoBean.produto.marca}" required="true"
                                 requiredMessage="O campo 'descrição é obrigatório" />

                    <p:outputLabel value="Descrição:" />
                    <p:inputText maxlength="50" size="30"
                                 value="#{produtoBean.produto.descricao}" required="true"
                                 requiredMessage="O campo 'descrição é obrigatório" />



                    <p:outputLabel value="Validade:" />
                    <p:calendar 
                        value="#{produtoBean.produto.validade}" required="true"
                        requiredMessage="O campo 'Data de Cadastro' é obrigatório"
                        size="10" locale="pt_BR" />





                </h:panelGrid>


                <h:panelGrid columns="2">
                    <p:commandButton value="Salvar"
                                     actionListener="#{produtoBean.salvar}"
                                     update=":mensagem :formCadastro:painel :formListagem:tabela" oncomplete="PF('dialogo').hide();" />
                    <p:commandButton value="Fechar" oncomplete="PF('dialogo').hide();" />
                </h:panelGrid>
            </h:form>
        </p:dialog>
    </ui:define>

</ui:composition>